//+-----------------------------------------------------------------------------------------------------------------------------+
//|                                                                                             ZH_StandardFunctionsTfH2.lib.mq4|
//|                                                                                             Copyright  Zhunko              |
//|09.10.2009 - 12.10.2009                                                                      F ZHUNKO vadim@zhunko.ru       |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|      H2.                                                                                        |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|1.    H2.                                                                                                  |
//|  int iBars_H2 (string symbol); //   .                                                               |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|2.      H2.                                                                                             |
//|  int iBarShift_H2 (string   symbol, //   .                                                          |
//|                    datetime time,   //    .                                                         |
//|                    bool     exact)  //                                                   |
//|                                     // (FALSE - iBarShift  /TRUE - iBarShift  -1).             |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|3.       H2.                                                                                     |
//|  datetime iTime_H2 (string symbol, //                                                               |
//|                     int    shift)  //  .                                                                           |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|4.      H2.                                                                                     |
//|  double iOpen_H2 (string symbol, //   .                                                             |
//|                   int    shift)  //  .                                                                             |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|5.      H2.                                                                                 |
//|  double iHigh_H2 (string symbol, //   .                                                             |
//|                   int    shift)  //  .                                                                             |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|6.      H2.                                                                                  |
//|  double iLow_H2 (string symbol, //  .                                                                          |
//|                  int    shift)  //  .                                                                              |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|7.      H2.                                                                                     |
//|  double iClose_H2 (string symbol, //   .                                                            |
//|                    int    shift)  //  .                                                                            |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|8.           .                             |
//|   int Hour2()                                                                                                               |
//+-----------------------------------------------------------------------------------------------------------------------------+
//|9.         .                                                       |
//|   int TimeHour2 (datetime time) // ,     ,   00:00 1  1970 . |
//+-----------------------------------------------------------------------------------------------------------------------------+
//
#property copyright "Copyright  2006 Zhunko"
#property link      "vadim@zhunko.ru"
#property library
//
// 1.     H2.
int iBars_H2 (string symbol) //   .
 {
  datetime iTimeH1;          //    .
  int      i, j;
  int      iBarsH1;          //     H1  .
  int      iBarsH2;          //     H2.
  // .
  bool     ArSwitch[12];     //    .
  //----
  ArrayInitialize (ArSwitch, true);
  iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  for (i = 0, iBarsH2 = 0; i < iBarsH1; i++)
   {
    iTimeH1 = iTime (symbol, PERIOD_H1, i); //    .
    //      .   ,    .            (  ).
    if (i > 0) if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0) ArrayInitialize (ArSwitch, true);
    //    .
    switch (TimeHour (iTimeH1))
     {//----  12-  .-----------------------------------------------------------------------------------------
      case 23:
      case 22:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 11) ArSwitch[j] = true;
        if (ArSwitch[11] == true) //   .
         {
          iBarsH2++;              //   .
          ArSwitch[11] = false;   //         .
          break;                  //   .
         }
        else continue;            //    ,       .
       }
      //----  11-  .-----------------------------------------------------------------------------------------
      case 21:
      case 20:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 10) ArSwitch[j] = true;
        if (ArSwitch[10] == true) //   .
         {
          iBarsH2++;              //   .
          ArSwitch[10] = false;   //         .
          break;                  //   .
         }
        else continue;            //    ,       .
       }
      //----  10-  .-----------------------------------------------------------------------------------------
      case 19:
      case 18:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 9) ArSwitch[j] = true;
        if (ArSwitch[9] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[9] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  9-  .------------------------------------------------------------------------------------------
      case 17:
      case 16:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 8) ArSwitch[j] = true;
        if (ArSwitch[8] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[8] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  8-  .------------------------------------------------------------------------------------------
      case 15:
      case 14:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 7) ArSwitch[j] = true;
        if (ArSwitch[7] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[7] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  7-  .------------------------------------------------------------------------------------------
      case 13:
      case 12:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 6) ArSwitch[j] = true;
        if (ArSwitch[6] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[6] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  6-  .------------------------------------------------------------------------------------------
      case 11:
      case 10:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 5) ArSwitch[j] = true;
        if (ArSwitch[5] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[5] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  5-  .------------------------------------------------------------------------------------------
      case  9:
      case  8:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 4) ArSwitch[j] = true;
        if (ArSwitch[4] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[4] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  4-  .------------------------------------------------------------------------------------------
      case  7:
      case  6:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 3) ArSwitch[j] = true;
        if (ArSwitch[3] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[3] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  3-  .------------------------------------------------------------------------------------------
      case 5:
      case 4:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 2) ArSwitch[j] = true;
        if (ArSwitch[2] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[2] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  2-  .------------------------------------------------------------------------------------------
      case 3:
      case 2:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 1) ArSwitch[j] = true;
        if (ArSwitch[1] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[1] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
      //----  1-  .------------------------------------------------------------------------------------------
      case 1:
      case 0:
       {//     H2,  .
        for (j = 0; j < 12; j++) if (j != 0) ArSwitch[j] = true;
        if (ArSwitch[0] == true) //   .
         {
          iBarsH2++;             //   .
          ArSwitch[0] = false;   //         .
          break;                 //   .
         }
        else continue;           //    ,       .
       }
     }
   }
  return (iBarsH2);
 }
//
// 2.       H2.
int iBarShift_H2 (string   symbol, //   .
                  datetime time,   //    .
                  bool     exact)  //       (FALSE - iBarShift  /TRUE - iBarShift  -1).
 {
  datetime TimeFirst_H2;     //     H2  .    .
  datetime TimeLast_H2;      //     H2  .
  datetime iTimeH1;          //      H1.
  datetime iTimeH2_0;        //      H2.
  datetime iTimeH2_1;        //      H2.
  int      AmountBar;        //         .
  int      i, j;
  int      ShiftH2 = 0;      //       H2.
  int      iBarsH1;          //     H1  .
  int      NumberHour;       //  .
  // .
  bool     ArSwitch[12];     //    .
  //----
  ArrayInitialize (ArSwitch, true);
  //==== .================================================================================================================================================================================================================
  iBarsH1 = iBars (symbol, PERIOD_H1);                    //     H1  .
  //====       .    .==========================================================================================================================================
  TimeFirst_H2 = iTime (symbol, PERIOD_H1, iBarsH1 - 1);  //       .
  NumberHour = TimeHour (TimeFirst_H2) + 1;               //    1  24.
  //       .
  if (MathMod (NumberHour, 2) == 0) TimeFirst_H2 += 3600; //      H2,   1- .
  else TimeFirst_H2 += 7200;                              //      H2,   2- .
  //====       .===================================================================================================================================================================
  TimeLast_H2 = iTime (symbol, PERIOD_H1, 0);             //       .
  NumberHour = TimeHour (TimeLast_H2) + 1;                //    1  24.
  //       .
  if (MathMod (NumberHour, 2) == 0) TimeFirst_H2 -= 3600; //      H2,   1- .
  //----.----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//  Comment ("TimeFirst_H2 = ", TimeToStr (TimeFirst_H2, TIME_DATE|TIME_MINUTES|TIME_SECONDS), "\nLastQuarter = ", TimeToStr (TimeLast_H2, TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  //======================================================================================================================================================================================================================================
  if (time < TimeFirst_H2 || time >= TimeLast_H2)              //     ,              . 
   {
    if (exact == true) return (-1);                            //   ,   -1    .
    else                                                       //   ,       () .
     {
      if (time < TimeFirst_H2) return (iBars_H2 (symbol) - 1); //          ,   .
      if (time > TimeLast_H2) return (0);                      //          ,   .
     }
   }
  else                                                      //       .
   {//      H2.
    iTimeH2_0 = iTime (symbol, PERIOD_H1, 0);               //       .
    NumberHour = TimeHour (iTimeH2_0) + 1;                  //  .
    if (MathMod (NumberHour, 2) == 0) TimeFirst_H2 += 3600; //      H2,   1- .
    else TimeFirst_H2 += 7200;                              //      H2,   2- .
    for (i = 0, ShiftH2 = -1; i < iBarsH1; i++)             //    .    .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);               //     .
      //      .   ,    .            (  ).
      if (i > 0) if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0) ArrayInitialize (ArSwitch, true);
      //    .
      NumberHour = TimeHour (iTimeH1); //  .
      switch (NumberHour)
       {//----  12-  .-----------------------------------------------------------------------------------------
        case 23:
        case 22:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 11) ArSwitch[j] = true;
          if (ArSwitch[11] == true) //   .
           {
            ShiftH2++;              //   .
            ArSwitch[11] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  11-  .-----------------------------------------------------------------------------------------
        case 21:
        case 20:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 10) ArSwitch[j] = true;
          if (ArSwitch[10] == true) //   .
           {
            ShiftH2++;              //   .
            ArSwitch[10] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  10-  .-----------------------------------------------------------------------------------------
        case 19:
        case 18:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 9) ArSwitch[j] = true;
          if (ArSwitch[9] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[9] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  9-  .------------------------------------------------------------------------------------------
        case 17:
        case 16:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 8) ArSwitch[j] = true;
          if (ArSwitch[8] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[8] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  8-  .------------------------------------------------------------------------------------------
        case 15:
        case 14:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 7) ArSwitch[j] = true;
          if (ArSwitch[7] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[7] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  7-  .------------------------------------------------------------------------------------------
        case 13:
        case 12:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 6) ArSwitch[j] = true;
          if (ArSwitch[6] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[6] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  6-  .------------------------------------------------------------------------------------------
        case 11:
        case 10:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 5) ArSwitch[j] = true;
          if (ArSwitch[5] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[5] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  5-  .------------------------------------------------------------------------------------------
        case  9:
        case  8:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 4) ArSwitch[j] = true;
          if (ArSwitch[4] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[4] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  4-  .------------------------------------------------------------------------------------------
        case  7:
        case  6:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 3) ArSwitch[j] = true;
          if (ArSwitch[3] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[3] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  3-  .------------------------------------------------------------------------------------------
        case 5:
        case 4:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 2) ArSwitch[j] = true;
          if (ArSwitch[2] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[2] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  2-  .------------------------------------------------------------------------------------------
        case 3:
        case 2:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 1) ArSwitch[j] = true;
          if (ArSwitch[1] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[1] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  1-  .------------------------------------------------------------------------------------------
        case 1:
        case 0:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 0) ArSwitch[j] = true;
          if (ArSwitch[0] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[0] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         } 
       }
      //   ,       "" .
      if (exact == true)
       {//      .
        iTimeH2_1 = iTimeH1;                                        //       .
        //       .
        if (MathMod (NumberHour + 1, 2) == 0) TimeFirst_H2 += 3600; //      H2,   1- .
        else TimeFirst_H2 += 7200;                                  //      H2,   2- .
        //   ""  .
        if (iTimeH2_1 < time && time < iTimeH2_0) return (-1);      //  -1    .
       }
      //      .
      iTimeH2_0 = iTimeH1;                                          //       .
      //       .
      if (MathMod (NumberHour + 1, 2) == 0) TimeFirst_H2 -= 3600;   //      H2,   1- .
      else TimeFirst_H2 += 7200;                                    //      H2,   2- .
      if (time >= iTimeH2_0) return (ShiftH2);           //      H2.
     }
   }
 }
//
// 3.        H2.
datetime iTime_H2 (string symbol, //   
                   int    shift)  //  .
 {
  datetime iTimeH1;   //    .
  int      AmountBar; //         .
  int      i, j;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH2 = iBars_H2 (symbol);         //     H2.
  int      NumberHour;                          //  .
  int      ShiftH2;                             //     H2.
  // .
  bool     ArSwitch[12];     //    .
  //----
  ArrayInitialize (ArSwitch, true);
  //----
  if (0 > shift || shift >= iBarsH2) return (0); //     .
  else                                           //       ,  .
   {//    .   .
    for (i = 0, ShiftH2 = -1; i < iBarsH1; i++)  //     .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
      //      .   ,    .            (  ).
      if (i > 0) if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0) ArrayInitialize (ArSwitch, true);
      //    .
      NumberHour = TimeHour (iTimeH1); //  .
      switch (NumberHour)
       {//----  12-  .-----------------------------------------------------------------------------------------
        case 23:
        case 22:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 11) ArSwitch[j] = true;
          if (ArSwitch[11] == true) //   .
           {
            ShiftH2++;              //   .
            ArSwitch[11] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  11-  .-----------------------------------------------------------------------------------------
        case 21:
        case 20:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 10) ArSwitch[j] = true;
          if (ArSwitch[10] == true) //   .
           {
            ShiftH2++;              //   .
            ArSwitch[10] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  10-  .-----------------------------------------------------------------------------------------
        case 19:
        case 18:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 9) ArSwitch[j] = true;
          if (ArSwitch[9] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[9] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  9-  .------------------------------------------------------------------------------------------
        case 17:
        case 16:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 8) ArSwitch[j] = true;
          if (ArSwitch[8] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[8] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  8-  .------------------------------------------------------------------------------------------
        case 15:
        case 14:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 7) ArSwitch[j] = true;
          if (ArSwitch[7] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[7] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  7-  .------------------------------------------------------------------------------------------
        case 13:
        case 12:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 6) ArSwitch[j] = true;
          if (ArSwitch[6] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[6] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  6-  .------------------------------------------------------------------------------------------
        case 11:
        case 10:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 5) ArSwitch[j] = true;
          if (ArSwitch[5] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[5] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  5-  .------------------------------------------------------------------------------------------
        case  9:
        case  8:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 4) ArSwitch[j] = true;
          if (ArSwitch[4] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[4] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  4-  .------------------------------------------------------------------------------------------
        case  7:
        case  6:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 3) ArSwitch[j] = true;
          if (ArSwitch[3] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[3] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  3-  .------------------------------------------------------------------------------------------
        case 5:
        case 4:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 2) ArSwitch[j] = true;
          if (ArSwitch[2] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[2] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  2-  .------------------------------------------------------------------------------------------
        case 3:
        case 2:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 1) ArSwitch[j] = true;
          if (ArSwitch[1] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[1] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  1-  .------------------------------------------------------------------------------------------
        case 1:
        case 0:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 0) ArSwitch[j] = true;
          if (ArSwitch[0] == true) //   .
           {
            ShiftH2++;             //   .
            ArSwitch[0] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
       }
      //    .
      if (shift == ShiftH2)
       {//       .
        if (MathMod (NumberHour + 1, 2) == 0) return (iTimeH1 - 3600); //      H2,   1- .
        else return (iTimeH1);                                         //     .
       }
     }
   }
 }
//
// 4.       H2.
double iOpen_H2 (string symbol, //   .
                 int    shift)  //  .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;          //    .
  int      i, j, k;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH2 = iBars_H2 (symbol);         //     H2.
  int      FirstH1;                             //     2-  .
  int      ShiftH2;                             //     H2.
  // .
  bool     ArSwitch[12];     //    .
  //----
  ArrayInitialize (ArSwitch, true);
  //----
  if (0 > shift || shift >= iBarsH2) return (0); //     .
  else                                           //       ,  .
   {
    for (i = 0, ShiftH2 = -1; i < iBarsH1; i++)  //     .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
      //      .   ,    .            (  ).
      if (i > 0) if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0) ArrayInitialize (ArSwitch, true);
      //    .
      switch (TimeHour (iTimeH1))
       {//----  12-  .-----------------------------------------------------------------------------------------
        case 23:
        case 22:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 11) ArSwitch[j] = true;
          if (ArSwitch[11] == true) //   .
           {
            ShiftH2++;              //   .
            FirstH1 = 22;           //     2-  .
            ArSwitch[11] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  11-  .-----------------------------------------------------------------------------------------
        case 21:
        case 20:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 10) ArSwitch[j] = true;
          if (ArSwitch[10] == true) //   .
           {
            ShiftH2++;              //   .
            FirstH1 = 20;           //     2-  .
            ArSwitch[10] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  10-  .-----------------------------------------------------------------------------------------
        case 19:
        case 18:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 9) ArSwitch[j] = true;
          if (ArSwitch[9] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 18;          //     2-  .
            ArSwitch[9] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  9-  .------------------------------------------------------------------------------------------
        case 17:
        case 16:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 8) ArSwitch[j] = true;
          if (ArSwitch[8] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 16;          //     2-  .
            ArSwitch[8] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  8-  .------------------------------------------------------------------------------------------
        case 15:
        case 14:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 7) ArSwitch[j] = true;
          if (ArSwitch[7] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 14;          //     2-  .
            ArSwitch[7] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  7-  .------------------------------------------------------------------------------------------
        case 13:
        case 12:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 6) ArSwitch[j] = true;
          if (ArSwitch[6] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 12;          //     2-  .
            ArSwitch[6] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  6-  .------------------------------------------------------------------------------------------
        case 11:
        case 10:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 5) ArSwitch[j] = true;
          if (ArSwitch[5] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 10;          //     2-  .
            ArSwitch[5] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  5-  .------------------------------------------------------------------------------------------
        case  9:
        case  8:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 4) ArSwitch[j] = true;
          if (ArSwitch[4] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 8;           //     2-  .
            ArSwitch[4] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  4-  .------------------------------------------------------------------------------------------
        case  7:
        case  6:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 3) ArSwitch[j] = true;
          if (ArSwitch[3] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 6;           //     2-  .
            ArSwitch[3] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  3-  .------------------------------------------------------------------------------------------
        case 5:
        case 4:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 2) ArSwitch[j] = true;
          if (ArSwitch[2] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 4;           //     2-  .
            ArSwitch[2] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  2-  .------------------------------------------------------------------------------------------
        case 3:
        case 2:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 1) ArSwitch[j] = true;
          if (ArSwitch[1] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 2;           //     2-  .
            ArSwitch[1] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  1-  .------------------------------------------------------------------------------------------
        case 1:
        case 0:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 0) ArSwitch[j] = true;
          if (ArSwitch[0] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 0;           //     2-  .
            ArSwitch[0] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         } 
       }
      //------------------------------------------------------------------------------------------------------------------------------------
      if (shift == ShiftH2) //    .
       {
        for (i++, k = TimeDay (iTimeH1);; i++) //      .
         {
          iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
          //     2-        .  ,         .    6-  .
          if (FirstH1 == 0) {if (TimeHour (iTimeH1) > 1 || TimeDay (iTimeH1) != k) return (iOpen (symbol, PERIOD_H1, i - 1));}
          else {if (TimeHour (iTimeH1) < FirstH1 || TimeDay (iTimeH1) != k) return (iOpen (symbol, PERIOD_H1, i - 1));}
         }
       }
     }
   }
 }
//
// 5.       H2.
double iHigh_H2 (string symbol, //   .
                 int    shift)  //  .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;          //    .
  datetime iTimeH1_1;        //     .
  int      i, j, k, l;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH2 = iBars_H2 (symbol);         //     H2.
  int      FirstH1;                             //     2-  .
  int      ShiftH2;                             //     H2.
  // .
  bool     ArSwitch[12]; //    .
  //----
  ArrayInitialize (ArSwitch, true);
  //----
  if (0 > shift || shift >= iBarsH2) return (0); //     .
  else                                           //       ,  .
   {
    for (i = 0, ShiftH2 = -1; i < iBarsH1; i++)  //     .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
      //      .   ,    .            (  ).
      if (i > 0) if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0) ArrayInitialize (ArSwitch, true);
      //    .
      switch (TimeHour (iTimeH1))
       {//----  12-  .-----------------------------------------------------------------------------------------
        case 23:
        case 22:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 11) ArSwitch[j] = true;
          if (ArSwitch[11] == true) //   .
           {
            ShiftH2++;              //   .
            FirstH1 = 22;           //     2-  .
            ArSwitch[11] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  11-  .-----------------------------------------------------------------------------------------
        case 21:
        case 20:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 10) ArSwitch[j] = true;
          if (ArSwitch[10] == true) //   .
           {
            ShiftH2++;              //   .
            FirstH1 = 20;           //     2-  .
            ArSwitch[10] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  10-  .-----------------------------------------------------------------------------------------
        case 19:
        case 18:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 9) ArSwitch[j] = true;
          if (ArSwitch[9] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 18;          //     2-  .
            ArSwitch[9] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  9-  .------------------------------------------------------------------------------------------
        case 17:
        case 16:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 8) ArSwitch[j] = true;
          if (ArSwitch[8] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 16;          //     2-  .
            ArSwitch[8] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  8-  .------------------------------------------------------------------------------------------
        case 15:
        case 14:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 7) ArSwitch[j] = true;
          if (ArSwitch[7] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 14;          //     2-  .
            ArSwitch[7] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  7-  .------------------------------------------------------------------------------------------
        case 13:
        case 12:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 6) ArSwitch[j] = true;
          if (ArSwitch[6] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 12;          //     2-  .
            ArSwitch[6] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  6-  .------------------------------------------------------------------------------------------
        case 11:
        case 10:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 5) ArSwitch[j] = true;
          if (ArSwitch[5] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 10;          //     2-  .
            ArSwitch[5] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  5-  .------------------------------------------------------------------------------------------
        case  9:
        case  8:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 4) ArSwitch[j] = true;
          if (ArSwitch[4] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 8;           //     2-  .
            ArSwitch[4] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  4-  .------------------------------------------------------------------------------------------
        case  7:
        case  6:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 3) ArSwitch[j] = true;
          if (ArSwitch[3] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 6;           //     2-  .
            ArSwitch[3] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  3-  .------------------------------------------------------------------------------------------
        case 5:
        case 4:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 2) ArSwitch[j] = true;
          if (ArSwitch[2] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 4;           //     2-  .
            ArSwitch[2] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  2-  .------------------------------------------------------------------------------------------
        case 3:
        case 2:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 1) ArSwitch[j] = true;
          if (ArSwitch[1] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 2;           //     2-  .
            ArSwitch[1] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  1-  .------------------------------------------------------------------------------------------
        case 1:
        case 0:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 0) ArSwitch[j] = true;
          if (ArSwitch[0] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 0;           //     2-  .
            ArSwitch[0] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         } 
       }
      //------------------------------------------------------------------------------------------------------------------------------------
      if (shift == ShiftH2) //    .
       {
        iTimeH1_1 = iTime (symbol, PERIOD_H1, i + 1); //     .
        //         .     2-        .
        if (FirstH1 == 0) {if (TimeHour (iTimeH1_1) > 1 || TimeDay (iTimeH1) != TimeDay (iTimeH1_1)) return (iHigh (symbol, PERIOD_H1, i));}
        else {if (TimeHour (iTimeH1_1) < FirstH1 || TimeDay (iTimeH1) != TimeDay (iTimeH1_1)) return (iHigh (symbol, PERIOD_H1, i));}
        //    H1     H2.
        return (MathMax (iHigh (symbol, PERIOD_H1, i), iHigh (symbol, PERIOD_H1, i + 1)));
       }
     }
   }
 }
//
// 6.       H2.
double iLow_H2 (string symbol, //  .
                int    shift)  //  .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;          //    .
  datetime iTimeH1_1;        //     .
  int      i, j, k, l;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH2 = iBars_H2 (symbol);         //     H2.
  int      FirstH1;                             //     2-  .
  int      ShiftH2;                             //     H2.
  // .
  bool     ArSwitch[12]; //    .
  //----
  ArrayInitialize (ArSwitch, true);
  //----
  if (0 > shift || shift >= iBarsH2) return (0); //     .
  else                                           //       ,  .
   {
    for (i = 0, ShiftH2 = -1; i < iBarsH1; i++)  //     .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
      //      .   ,    .            (  ).
      if (i > 0) if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0) ArrayInitialize (ArSwitch, true);
      //    .
      switch (TimeHour (iTimeH1))
       {//----  12-  .-----------------------------------------------------------------------------------------
        case 23:
        case 22:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 11) ArSwitch[j] = true;
          if (ArSwitch[11] == true) //   .
           {
            ShiftH2++;              //   .
            FirstH1 = 22;           //     2-  .
            ArSwitch[11] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  11-  .-----------------------------------------------------------------------------------------
        case 21:
        case 20:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 10) ArSwitch[j] = true;
          if (ArSwitch[10] == true) //   .
           {
            ShiftH2++;              //   .
            FirstH1 = 20;           //     2-  .
            ArSwitch[10] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  10-  .-----------------------------------------------------------------------------------------
        case 19:
        case 18:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 9) ArSwitch[j] = true;
          if (ArSwitch[9] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 18;          //     2-  .
            ArSwitch[9] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  9-  .------------------------------------------------------------------------------------------
        case 17:
        case 16:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 8) ArSwitch[j] = true;
          if (ArSwitch[8] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 16;          //     2-  .
            ArSwitch[8] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  8-  .------------------------------------------------------------------------------------------
        case 15:
        case 14:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 7) ArSwitch[j] = true;
          if (ArSwitch[7] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 14;          //     2-  .
            ArSwitch[7] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  7-  .------------------------------------------------------------------------------------------
        case 13:
        case 12:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 6) ArSwitch[j] = true;
          if (ArSwitch[6] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 12;          //     2-  .
            ArSwitch[6] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  6-  .------------------------------------------------------------------------------------------
        case 11:
        case 10:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 5) ArSwitch[j] = true;
          if (ArSwitch[5] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 10;          //     2-  .
            ArSwitch[5] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  5-  .------------------------------------------------------------------------------------------
        case  9:
        case  8:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 4) ArSwitch[j] = true;
          if (ArSwitch[4] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 8;           //     2-  .
            ArSwitch[4] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  4-  .------------------------------------------------------------------------------------------
        case  7:
        case  6:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 3) ArSwitch[j] = true;
          if (ArSwitch[3] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 6;           //     2-  .
            ArSwitch[3] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  3-  .------------------------------------------------------------------------------------------
        case 5:
        case 4:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 2) ArSwitch[j] = true;
          if (ArSwitch[2] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 4;           //     2-  .
            ArSwitch[2] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  2-  .------------------------------------------------------------------------------------------
        case 3:
        case 2:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 1) ArSwitch[j] = true;
          if (ArSwitch[1] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 2;           //     2-  .
            ArSwitch[1] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  1-  .------------------------------------------------------------------------------------------
        case 1:
        case 0:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 0) ArSwitch[j] = true;
          if (ArSwitch[0] == true) //   .
           {
            ShiftH2++;             //   .
            FirstH1 = 0;           //     2-  .
            ArSwitch[0] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         } 
       }
      //-----------------------------------------------------------------------------------------------------------------------------------
      if (shift == ShiftH2) //    .
       {
        iTimeH1_1 = iTime (symbol, PERIOD_H1, i + 1); //     .
        //         .     2-        .
        if (FirstH1 == 0) {if (TimeHour (iTimeH1_1) > 1 || TimeDay (iTimeH1) != TimeDay (iTimeH1_1)) return (iHigh (symbol, PERIOD_H1, i));}
        else {if (TimeHour (iTimeH1_1) < FirstH1 || TimeDay (iTimeH1) != TimeDay (iTimeH1_1)) return (iHigh (symbol, PERIOD_H1, i));}
        //    H1     H2.
        return (MathMin (iLow (symbol, PERIOD_H1, i), iLow (symbol, PERIOD_H1, i + 1)));
       }
     }
   }
 }
//
// 7.       H2.
double iClose_H2 (string symbol, //   .
                  int    shift)  //  .
 {
  datetime iTimeH1;                             //    .
  int      i, j;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH2 = iBars_H2 (symbol);         //        H2.
  // .
  bool     ArSwitch[12]; //    .
  //----
  ArrayInitialize (ArSwitch, true);
  //      .
  if (0 > shift || shift >= iBarsH2) return (0); //     .
  else                                           //       ,  .
   {
    iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
    for (i = 0, iBarsH2 = -1; i < iBarsH1; i++)
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i); //    .
      //      .   ,    .            (  ).
      if (i > 0) if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0) ArrayInitialize (ArSwitch, true);
      //    .
      switch (TimeHour (iTimeH1))
       {//----  12-  .-----------------------------------------------------------------------------------------
        case 23:
        case 22:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 11) ArSwitch[j] = true;
          if (ArSwitch[11] == true) //   .
           {
            iBarsH2++;              //   .
            ArSwitch[11] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  11-  .-----------------------------------------------------------------------------------------
        case 21:
        case 20:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 10) ArSwitch[j] = true;
          if (ArSwitch[10] == true) //   .
           {
            iBarsH2++;              //   .
            ArSwitch[10] = false;   //         .
            break;                  //   .
           }
          else continue;            //    ,       .
         }
        //----  10-  .-----------------------------------------------------------------------------------------
        case 19:
        case 18:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 9) ArSwitch[j] = true;
          if (ArSwitch[9] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[9] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  9-  .------------------------------------------------------------------------------------------
        case 17:
        case 16:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 8) ArSwitch[j] = true;
          if (ArSwitch[8] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[8] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  8-  .------------------------------------------------------------------------------------------
        case 15:
        case 14:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 7) ArSwitch[j] = true;
          if (ArSwitch[7] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[7] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  7-  .------------------------------------------------------------------------------------------
        case 13:
        case 12:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 6) ArSwitch[j] = true;
          if (ArSwitch[6] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[6] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  6-  .------------------------------------------------------------------------------------------
        case 11:
        case 10:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 5) ArSwitch[j] = true;
          if (ArSwitch[5] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[5] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  5-  .------------------------------------------------------------------------------------------
        case  9:
        case  8:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 4) ArSwitch[j] = true;
          if (ArSwitch[4] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[4] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  4-  .------------------------------------------------------------------------------------------
        case  7:
        case  6:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 3) ArSwitch[j] = true;
          if (ArSwitch[3] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[3] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  3-  .------------------------------------------------------------------------------------------
        case 5:
        case 4:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 2) ArSwitch[j] = true;
          if (ArSwitch[2] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[2] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  2-  .------------------------------------------------------------------------------------------
        case 3:
        case 2:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 1) ArSwitch[j] = true;
          if (ArSwitch[1] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[1] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         }
        //----  1-  .------------------------------------------------------------------------------------------
        case 1:
        case 0:
         {//     H2,  .
          for (j = 0; j < 12; j++) if (j != 0) ArSwitch[j] = true;
          if (ArSwitch[0] == true) //   .
           {
            iBarsH2++;             //   .
            ArSwitch[0] = false;   //         .
            break;                 //   .
           }
          else continue;           //    ,       .
         } 
       }
      //------------------------------------------------------------------------------------------------------------------------------------
      if (shift == iBarsH2) return (iClose (symbol, PERIOD_H1, i)); //    .     .
     }
   }
 }
//
// 8.           .
int Hour2()
 {
  switch (Hour())
   {
    case  0:
    case  1: return  (1);
    case  2:
    case  3: return  (2);
    case  4:
    case  5: return  (3);
    case  6:
    case  7: return  (4);
    case  8:
    case  9: return  (5);
    case 10:
    case 11: return  (6);
    case 12:
    case 13: return  (7);
    case 14:
    case 15: return  (8);
    case 16:
    case 17: return  (9);
    case 18:
    case 19: return (10);
    case 20:
    case 21: return (11);
    case 22:
    case 23: return (12);
   }
 }
//
// 8.           .
int TimeHour2 (datetime time)
 {
  switch (TimeHour (time)) // ,     ,   00:00 1  1970 .
   {
    case  0:
    case  1: return  (1);
    case  2:
    case  3: return  (2);
    case  4:
    case  5: return  (3);
    case  6:
    case  7: return  (4);
    case  8:
    case  9: return  (5);
    case 10:
    case 11: return  (6);
    case 12:
    case 13: return  (7);
    case 14:
    case 15: return  (8);
    case 16:
    case 17: return  (9);
    case 18:
    case 19: return (10);
    case 20:
    case 21: return (11);
    case 22:
    case 23: return (12);
   }
 }
//

